<?php
namespace Incoviba\Repository\Inmobiliaria;

use Incoviba\Common\Define;
use Incoviba\Common\Ideal;
use Incoviba\Common\Implement;
use Incoviba\Model;
use Incoviba\Repository;

class Agente extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Repository\Direccion $direccionRepository, protected TipoAgente $tipoAgenteRepository)
    {
        parent::__construct($connection);
        $this->setTable('agente');
    }

    public function create(?array $data = null): Model\Inmobiliaria\Agente
    {
        $map = (new Implement\Repository\MapperParser(['rut', 'descripcion', 'telefono', 'correo', 'giro', 'abreviacion']))
            ->register('representante', (new Implement\Repository\Mapper())
                ->setProperty('contacto'))
            ->register('direccion', (new Implement\Repository\Mapper())
                ->setFunction(function(?array $data) {
                    if ($data === null) {
                        return null;
                    }
                    return $this->direccionRepository->fetchById($data['direccion']);
                }));
        return $this->parseData(new Model\Inmobiliaria\Agente(), $data, $map);
    }
    public function save(Define\Model $model): Model\Inmobiliaria\Agente
    {
        $model->id = $this->saveNew([
            'rut', 'descripcion', 'representante', 'telefono', 'correo', 'giro', 'abreviacion'
        ], [
            $model->rut, $model->descripcion, $model->contacto, $model->telefono, $model->correo, $model->giro, $model->abreviacion
        ]);
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Model\Inmobiliaria\Agente
    {
        return $this->update($model, [
            'rut', 'descripcion', 'representante', 'telefono', 'correo', 'giro', 'abreviacion'
        ], $new_data);
    }
}
